Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -4389,23 +4626,23 @@
        INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
        
-       REAL(wp)    ::  ibit9  !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit11 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit0 !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit1 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit2 !< flag indicating 5th-order scheme along x-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit9_l  !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit10_l !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit11_l !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit0_l !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit1_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit2_l !< flag indicating 5th-order scheme along x-direction
 #endif
-       REAL(wp)    ::  ibit12 !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit14 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit3 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit4 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit5 !< flag indicating 5th-order scheme along y-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit12_s !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit13_s !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit14_s !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit3_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit4_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit5_s !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp)    ::  ibit15 !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit17 !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  ibit6  !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit8  !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< diverence on u-grid
@@ -4468,20 +4705,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit11 = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
-             ibit10 = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
-             ibit9  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
+             ibit2 = REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
 
              u_comp                   = u(k,j,i) + u(k,j,i-1) - gu
              swap_flux_x_local_u(k,j) = u_comp * (                             &
-                                       ( 37.0_wp * ibit11 * adv_mom_5          &
-                                    +     7.0_wp * ibit10 * adv_mom_3          &
-                                    +              ibit9  * adv_mom_1          &
+                                       ( 37.0_wp * ibit2 * adv_mom_5           &
+                                    +     7.0_wp * ibit1 * adv_mom_3           &
+                                    +              ibit0 * adv_mom_1          &
                                        ) *                                     &
                                      ( u(k,j,i)   + u(k,j,i-1) )               &
-                                -      (  8.0_wp * ibit11 * adv_mom_5          &
-                                    +              ibit10 * adv_mom_3          &
+                                -      (  8.0_wp * ibit2 * adv_mom_5           &
+                                    +              ibit1 * adv_mom_3           &
                                        ) *                                     &
                                      ( u(k,j,i+1) + u(k,j,i-2) )               &
-                                +      (           ibit11 * adv_mom_5          &
+                                +      (           ibit2 * adv_mom_5           &
                                        ) *                                     &
                                      ( u(k,j,i+2) + u(k,j,i-3) )               &
@@ -4489,14 +4726,14 @@
 
               swap_diss_x_local_u(k,j) = - ABS( u_comp ) * (                   &
-                                       ( 10.0_wp * ibit11 * adv_mom_5          &
-                                    +     3.0_wp * ibit10 * adv_mom_3          &
-                                    +              ibit9  * adv_mom_1          &
+                                       ( 10.0_wp * ibit2 * adv_mom_5           &
+                                    +     3.0_wp * ibit1 * adv_mom_3           &
+                                    +              ibit0 * adv_mom_1          &
                                        ) *                                     &
                                      ( u(k,j,i)   - u(k,j,i-1) )               &
-                                -      (  5.0_wp * ibit11 * adv_mom_5          &
-                                    +              ibit10 * adv_mom_3          &
+                                -      (  5.0_wp * ibit2 * adv_mom_5           &
+                                    +              ibit1 * adv_mom_3           &
                                        ) *                                     &
                                      ( u(k,j,i+1) - u(k,j,i-2) )               &
-                                +      (           ibit11 * adv_mom_5          &
+                                +      (           ibit2 * adv_mom_5           &
                                        ) *                                     &
                                      ( u(k,j,i+2) - u(k,j,i-3) )               &
@@ -4523,13 +4760,13 @@
        !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
        !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
-       !$ACC PRIVATE(ibit9, ibit10, ibit11, ibit12, ibit13, ibit14) &
-       !$ACC PRIVATE(ibit9_l, ibit10_l, ibit11_l) &
-       !$ACC PRIVATE(ibit12_s, ibit13_s, ibit14_s) &
-       !$ACC PRIVATE(ibit15, ibit16, ibit17) &
+       !$ACC PRIVATE(ibit0, ibit1, ibit2, ibit3, ibit4, ibit5) &
+       !$ACC PRIVATE(ibit0_l, ibit1_l, ibit2_l) &
+       !$ACC PRIVATE(ibit3_s, ibit4_s, ibit5_s) &
+       !$ACC PRIVATE(ibit6, ibit7, ibit8) &
        !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
        !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
-       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(advc_flags_m) &
        !$ACC PRESENT(u, v, w) &
        !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
@@ -4545,37 +4782,37 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit14 = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
-             ibit13 = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
-             ibit12 = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
+             ibit5 = REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
 
              v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-             swap_flux_y_local_u(k) = v_comp * (                              &
-                                   ( 37.0_wp * ibit14 * adv_mom_5             &
-                                +     7.0_wp * ibit13 * adv_mom_3             &
-                                +              ibit12 * adv_mom_1             &
-                                   ) *                                        &
-                                     ( u(k,j,i)   + u(k,j-1,i) )              &
-                            -      (  8.0_wp * ibit14 * adv_mom_5             &
-                            +                  ibit13 * adv_mom_3             &
-                                   ) *                                        &
-                                     ( u(k,j+1,i) + u(k,j-2,i) )              &
-                        +      (               ibit14 * adv_mom_5             &
-                               ) *                                            &
-                                     ( u(k,j+2,i) + u(k,j-3,i) )              &
-                                               )
-
-             swap_diss_y_local_u(k) = - ABS ( v_comp ) * (                    &
-                                   ( 10.0_wp * ibit14 * adv_mom_5             &
-                                +     3.0_wp * ibit13 * adv_mom_3             &
-                                +              ibit12 * adv_mom_1             &
-                                   ) *                                        &
-                                     ( u(k,j,i)   - u(k,j-1,i) )              &
-                            -      (  5.0_wp * ibit14 * adv_mom_5             &
-                                +              ibit13 * adv_mom_3             &
-                                   ) *                                        &
-                                     ( u(k,j+1,i) - u(k,j-2,i) )              &
-                            +      (           ibit14 * adv_mom_5             &
-                                   ) *                                        &
-                                     ( u(k,j+2,i) - u(k,j-3,i) )              &
+             swap_flux_y_local_u(k) = v_comp * (                               &
+                                   ( 37.0_wp * ibit5 * adv_mom_5               &
+                                +     7.0_wp * ibit4 * adv_mom_3               &
+                                +              ibit3 * adv_mom_1               &
+                                   ) *                                         &
+                                     ( u(k,j,i)   + u(k,j-1,i) )               &
+                            -      (  8.0_wp * ibit5 * adv_mom_5               &
+                            +                  ibit4 * adv_mom_3               &
+                                   ) *                                         &
+                                     ( u(k,j+1,i) + u(k,j-2,i) )               &
+                        +      (               ibit5 * adv_mom_5               &
+                               ) *                                             &
+                                     ( u(k,j+2,i) + u(k,j-3,i) )               &
+                                               )                              
+                                                                              
+             swap_diss_y_local_u(k) = - ABS ( v_comp ) * (                     &
+                                   ( 10.0_wp * ibit5 * adv_mom_5               &
+                                +     3.0_wp * ibit4 * adv_mom_3               &
+                                +              ibit3 * adv_mom_1               &
+                                   ) *                                         &
+                                     ( u(k,j,i)   - u(k,j-1,i) )               &
+                            -      (  5.0_wp * ibit5 * adv_mom_5               &
+                                +              ibit4 * adv_mom_3               &
+                                   ) *                                         &
+                                     ( u(k,j+1,i) - u(k,j-2,i) )               &
+                            +      (           ibit5 * adv_mom_5               &
+                                   ) *                                         &
+                                     ( u(k,j+2,i) - u(k,j-3,i) )               &
                                                          )
 
@@ -4585,11 +4822,11 @@
 
              v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-             swap_flux_y_local_u(k) = v_comp * (                              &
-                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )                 &
-                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )                 &
+             swap_flux_y_local_u(k) = v_comp * (                               &
+                           37.0_wp * ( u(k,j,i)   + u(k,j-1,i) )               &
+                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
                          +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-             swap_diss_y_local_u(k) = - ABS(v_comp) * (                       &
-                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )                 &
-                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )                 &
+             swap_diss_y_local_u(k) = - ABS(v_comp) * (                        &
+                           10.0_wp * ( u(k,j,i)   - u(k,j-1,i) )               &
+                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
                          +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
 
@@ -4606,37 +4843,37 @@
              DO  k = nzb+1, nzb_max_l
 
-                ibit11 = REAL( IBITS(advc_flags_1(k,j,i),11,1), KIND = wp )
-                ibit10 = REAL( IBITS(advc_flags_1(k,j,i),10,1), KIND = wp )
-                ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
+                ibit2 = REAL( IBITS(advc_flags_m(k,j,i),2,1), KIND = wp )
+                ibit1 = REAL( IBITS(advc_flags_m(k,j,i),1,1), KIND = wp )
+                ibit0 = REAL( IBITS(advc_flags_m(k,j,i),0,1), KIND = wp )
 
                 u_comp = u(k,j,i+1) + u(k,j,i)
-                flux_r = ( u_comp - gu ) * (                                 &
-                          ( 37.0_wp * ibit11 * adv_mom_5                     &
-                       +     7.0_wp * ibit10 * adv_mom_3                     &
-                       +              ibit9  * adv_mom_1                     &
-                          ) *                                                &
-                                 ( u(k,j,i+1) + u(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit11 * adv_mom_5                     &
-                       +              ibit10 * adv_mom_3                     &
-                          ) *                                                &
-                                 ( u(k,j,i+2) + u(k,j,i-1) )                 &
-                   +      (           ibit11 * adv_mom_5                     &
-                          ) *                                                &
-                                 ( u(k,j,i+3) + u(k,j,i-2) )                 &
-                                                 )
-
-                diss_r = - ABS( u_comp - gu ) * (                            &
-                          ( 10.0_wp * ibit11 * adv_mom_5                     &
-                       +     3.0_wp * ibit10 * adv_mom_3                     & 
-                       +              ibit9  * adv_mom_1                     &
-                          ) *                                                &
-                                 ( u(k,j,i+1) - u(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit11 * adv_mom_5                     &
-                       +              ibit10 * adv_mom_3                     &
-                          ) *                                                &
-                                 ( u(k,j,i+2) - u(k,j,i-1) )                 &
-                   +      (           ibit11 * adv_mom_5                     &
-                          ) *                                                &
-                                 ( u(k,j,i+3) - u(k,j,i-2) )                 &
+                flux_r = ( u_comp - gu ) * (                                   &
+                          ( 37.0_wp * ibit2 * adv_mom_5                        &
+                       +     7.0_wp * ibit1 * adv_mom_3                        &
+                       +              ibit0  * adv_mom_1                       &
+                          ) *                                                  &
+                                 ( u(k,j,i+1) + u(k,j,i)   )                   &
+                   -      (  8.0_wp * ibit2 * adv_mom_5                        &
+                       +              ibit1 * adv_mom_3                        &
+                          ) *                                                  &
+                                 ( u(k,j,i+2) + u(k,j,i-1) )                   &
+                   +      (           ibit2 * adv_mom_5                        &
+                          ) *                                                  &
+                                 ( u(k,j,i+3) + u(k,j,i-2) )                   &
+                                                 )                            
+                                                                              
+                diss_r = - ABS( u_comp - gu ) * (                              &
+                          ( 10.0_wp * ibit2 * adv_mom_5                        &
+                       +     3.0_wp * ibit1 * adv_mom_3                        & 
+                       +              ibit0  * adv_mom_1                       &
+                          ) *                                                  &
+                                 ( u(k,j,i+1) - u(k,j,i)  )                    &
+                   -      (  5.0_wp * ibit2 * adv_mom_5                        &
+                       +              ibit1 * adv_mom_3                        &
+                          ) *                                                  &
+                                 ( u(k,j,i+2) - u(k,j,i-1) )                   &
+                   +      (           ibit2 * adv_mom_5                        &
+                          ) *                                                  &
+                                 ( u(k,j,i+3) - u(k,j,i-2) )                   &
                                                      )
 
@@ -4644,20 +4881,20 @@
 !
 !--             Recompute the left fluxes.
-                ibit11_l = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
-                ibit10_l = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
-                ibit9_l  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
+                ibit2_l = REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )
+                ibit1_l = REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )
+                ibit0_l = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
 
                 u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
                 flux_l   = u_comp_l * (                                        &
-                                       ( 37.0_wp * ibit11_l * adv_mom_5           &
-                                    +     7.0_wp * ibit10_l * adv_mom_3           &
-                                    +              ibit9_l  * adv_mom_1           &
+                                       ( 37.0_wp * ibit2_l * adv_mom_5         &
+                                    +     7.0_wp * ibit1_l * adv_mom_3         &
+                                    +              ibit0_l  * adv_mom_1        &
                                        ) *                                     &
                                      ( u(k,j,i)   + u(k,j,i-1) )               &
-                                -      (  8.0_wp * ibit11_l * adv_mom_5           &
-                                    +              ibit10_l * adv_mom_3           &
+                                -      (  8.0_wp * ibit2_l * adv_mom_5         &
+                                    +              ibit1_l * adv_mom_3         &
                                        ) *                                     &
                                      ( u(k,j,i+1) + u(k,j,i-2) )               &
-                                +      (           ibit11_l * adv_mom_5           &
+                                +      (           ibit2_l * adv_mom_5         &
                                        ) *                                     &
                                      ( u(k,j,i+2) + u(k,j,i-3) )               &
@@ -4665,14 +4902,14 @@
 
                 diss_l   = - ABS( u_comp_l ) * (                               &
-                                       ( 10.0_wp * ibit11_l * adv_mom_5           &
-                                    +     3.0_wp * ibit10_l * adv_mom_3           &
-                                    +              ibit9_l  * adv_mom_1           &
+                                       ( 10.0_wp * ibit2_l * adv_mom_5         &
+                                    +     3.0_wp * ibit1_l * adv_mom_3         &
+                                    +              ibit0_l  * adv_mom_1        &
                                        ) *                                     &
                                      ( u(k,j,i)   - u(k,j,i-1) )               &
-                                -      (  5.0_wp * ibit11_l * adv_mom_5           &
-                                    +              ibit10_l * adv_mom_3           &
+                                -      (  5.0_wp * ibit2_l * adv_mom_5         &
+                                    +              ibit1_l * adv_mom_3         &
                                        ) *                                     &
                                      ( u(k,j,i+1) - u(k,j,i-2) )               &
-                                +      (           ibit11_l * adv_mom_5           &
+                                +      (           ibit2_l * adv_mom_5         &
                                        ) *                                     &
                                      ( u(k,j,i+2) - u(k,j,i-3) )               &
@@ -4683,37 +4920,37 @@
 #endif
 
-                ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
-                ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
-                ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
+                ibit5 = REAL( IBITS(advc_flags_m(k,j,i),5,1), KIND = wp )
+                ibit4 = REAL( IBITS(advc_flags_m(k,j,i),4,1), KIND = wp )
+                ibit3 = REAL( IBITS(advc_flags_m(k,j,i),3,1), KIND = wp )
 
                 v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n = v_comp * (                                          &
-                          ( 37.0_wp * ibit14 * adv_mom_5                     &
-                       +     7.0_wp * ibit13 * adv_mom_3                     &
-                       +              ibit12 * adv_mom_1                     &
-                          ) *                                                &
-                                 ( u(k,j+1,i) + u(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit14 * adv_mom_5                     &
-                       +              ibit13 * adv_mom_3                     &
-                          ) *                                                &
-                                 ( u(k,j+2,i) + u(k,j-1,i) )                 &
-                   +      (           ibit14 * adv_mom_5                     & 
-                          ) *                                                &
-                                 ( u(k,j+3,i) + u(k,j-2,i) )                 &
-                                                 )
-
-                diss_n = - ABS ( v_comp ) * (                                &
-                          ( 10.0_wp * ibit14 * adv_mom_5                     &
-                       +     3.0_wp * ibit13 * adv_mom_3                     &
-                       +              ibit12 * adv_mom_1                     &
-                          ) *                                                &
-                                 ( u(k,j+1,i) - u(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit14 * adv_mom_5                     &
-                       +              ibit13 * adv_mom_3                     &
-                          ) *                                                &
-                                 ( u(k,j+2,i) - u(k,j-1,i) )                 &
-                   +      (           ibit14 * adv_mom_5                     &
-                          ) *                                                &
-                                 ( u(k,j+3,i) - u(k,j-2,i) )                 &
+                flux_n = v_comp * (                                            &
+                          ( 37.0_wp * ibit5 * adv_mom_5                        &
+                       +     7.0_wp * ibit4 * adv_mom_3                        &
+                       +              ibit3 * adv_mom_1                        &
+                          ) *                                                  &
+                                 ( u(k,j+1,i) + u(k,j,i)   )                   &
+                   -      (  8.0_wp * ibit5 * adv_mom_5                        &
+                       +              ibit4 * adv_mom_3                        &
+                          ) *                                                  &
+                                 ( u(k,j+2,i) + u(k,j-1,i) )                   &
+                   +      (           ibit5 * adv_mom_5                        & 
+                          ) *                                                  &
+                                 ( u(k,j+3,i) + u(k,j-2,i) )                   &
+                                                 )                            
+                                                                              
+                diss_n = - ABS ( v_comp ) * (                                  &
+                          ( 10.0_wp * ibit5 * adv_mom_5                        &
+                       +     3.0_wp * ibit4 * adv_mom_3                        &
+                       +              ibit3 * adv_mom_1                        &
+                          ) *                                                  &
+                                 ( u(k,j+1,i) - u(k,j,i)  )                    &
+                   -      (  5.0_wp * ibit5 * adv_mom_5                        &
+                       +              ibit4 * adv_mom_3                        &
+                          ) *                                                  &
+                                 ( u(k,j+2,i) - u(k,j-1,i) )                   &
+                   +      (           ibit5 * adv_mom_5                        &
+                          ) *                                                  &
+                                 ( u(k,j+3,i) - u(k,j-2,i) )                   &
                                                       )
 
